︠d17505dc-1e41-4de3-a88a-5c2c90fa7192︠
G = Graph(graphs.GridGraph([50,50]),  implementation='c_graph', sparse=True)
︡b3a5c6ac-8fe0-4572-ae66-bd09cd88b6cb︡︡
︠6d1e9cf2-40c5-48ec-aa80-fdd0837b6ac1︠
%cython

from sage.graphs.graph import Graph
from sage.all import graphs
from sage.graphs.base.sparse_graph cimport SparseGraph

def iterate1(G):
    cdef SparseGraph SG = <SparseGraph> G._backend._cg
    n=G.order()
    #cdef int i
    #cdef list nbrs
    nbrs=[]
    
    for i in range(n):
        nbrs.append(SG.in_neighbors(i))
    return nbrs
︡4da4d565-e096-4670-aaae-a0d6b62c3ca2︡︡
︠235fe2b4-a1f9-4451-a5f9-3846551a10ab︠
timeit('a=iterate1(G)')
︡766f8a01-3aa9-4df6-94b2-10257da16002︡{"stdout": "5 loops, best of 3: 71.8 ms per loop"}︡
︠f16bbf40-9f9f-4b44-8651-f326a7247d7b︠
%cython

from sage.graphs.graph import Graph
from sage.all import graphs
from sage.graphs.base.sparse_graph cimport SparseGraph

def iterate2(G):
    cdef SparseGraph SG = <SparseGraph> G._backend._cg
    
    cdef int i
    cdef int n = G.order()
    cdef list nbrs
    c=1

    cdef int *neighbors = <int *> sage_malloc(size * sizeof(int))
    if not neighbors:
        raise RuntimeError("Failure allocating memory.")
    num_nbrs = self.out_neighbors_unsafe(u, neighbors, size)
    output = [neighbors[i] for i from 0 <= i < num_nbrs]
    sage_free(neighbors)


    for i in range(n):
        c+=len(SG.in_neighbors_unsafe(i))
    return c
︡88231d2a-10ae-4d45-a9e4-408f97ec1686︡{"stderr": "Traceback (most recent call last):        \n  File \"\", line 1, in <module>\n    \n  File \"/sagenb/sage_install/sage-4.7/devel/rkirov-flask/sagenb/misc/support.py\", line 519, in cython_import_all\n    create_local_c_file=create_local_c_file)\n  File \"/sagenb/sage_install/sage-4.7/devel/rkirov-flask/sagenb/misc/support.py\", line 496, in cython_import\n    create_local_c_file=create_local_c_file)\n  File \"/sagenb/sage_install/sage-4.7/local/lib/python2.6/site-packages/sage/misc/cython.py\", line 367, in cython\n    raise RuntimeError, \"Error converting %s to C:\\n%s\\n%s\"%(filename, log, err)\nRuntimeError: Error converting /sagenb/servers/sage_notebook-sagenb.sagenb/home/jason3/456/code/sage60.spyx to C:\n\n\nError compiling Cython file:\n------------------------------------------------------------\n...\n    cdef int n = G.order()\n    cdef list nbrs\n    c=1\n    \n    for i in range(n):\n        c+=len(SG.in_neighbors_unsafe(i))\n                                    ^\n------------------------------------------------------------\n\n_sagenb_servers_sage_notebook_sagenb_sagenb_home_jason3_456_code_sage60_spyx_0.pyx:19:37: Call with wrong number of arguments (expected 4, got 2)"}︡
︠85465c5a-dcd0-49cc-a98b-9344fcd1ce04︠
timeit('a=iterate2(G)')
︡281b6555-f905-463f-ae44-64dbbff7dac9︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_48.py\", line 10, in <module>\n    exec compile(u'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"dGltZWl0KCdhPWl0ZXJhdGUyKEcpJyk=\"),globals())+\"\\\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpo_UQ3S/___code___.py\", line 2, in <module>\n    exec compile(u\"timeit('a=iterate2(G)')\" + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"sage_timeit_class.pyx\", line 82, in sage.misc.sage_timeit_class.SageTimeit.__call__ (sage/misc/sage_timeit_class.c:744)\n  File \"sage_timeit_class.pyx\", line 59, in sage.misc.sage_timeit_class.SageTimeit.eval (sage/misc/sage_timeit_class.c:605)\n  File \"/sagenb/sage_install/sage-4.7/local/lib/python2.6/site-packages/sage/misc/sage_timeit.py\", line 181, in sage_timeit\n    if timer.timeit(number) >= 0.2:\n  File \"/sagenb/sage_install/sage-4.7/local/lib/python/timeit.py\", line 193, in timeit\n    timing = self.inner(it, self.timer)\n  File \"<magic-timeit>\", line 6, in inner\n  File \"_sagenb_servers_sage_notebook_sagenb_sagenb_home_jason3_456_code_sage57_spyx_0.pyx\", line 19, in _sagenb_servers_sage_notebook_sagenb_sagenb_home_jason3_456_code_sage57_spyx_0.iterate2 (_sagenb_servers_sage_notebook_sagenb_sagenb_home_jason3_456_code_sage57_spyx_0.c:696)\n    c+=len(SG.neighbors_unsafe(i))\nAttributeError: 'sage.graphs.base.sparse_graph.SparseGraph' object has no attribute 'neighbors_unsafe'"}︡
︠2e935e19-cc93-4da3-a5d0-93f8173e84b5︠
def iterate_py(G):
    nbrs=[]
    for i in G.vertices():
        nbrs.append(G.neighbors(i))
    return nbrs
︡a83108fe-1bbd-4493-8f68-ce8aa410c39f︡︡
︠827e3bbc-b5a9-4311-a6e3-4b11f822b08d︠
timeit('a=iterate_py(G)')
︡edbb8f63-9c43-454c-b7e5-0f04c378f21e︡{"stdout": "5 loops, best of 3: 46.4 ms per loop"}︡
